// [Tercera prueba]

// Sobre la segunda prueba, poner la función que rellena el nametable de mierda en otra de las páginas. 
// Después de descomprimir, paginar esa ROM y llamar a la función. ¿se ve?

// De hecho, la función ejecutable estará en ROM1, y los datos en ROM2. Para petar.

#include "neslib-unrom.h"

#pragma bss-name (push,"ZEROPAGE")
#pragma data-name(push,"ZEROPAGE")

unsigned char gpit;

#pragma bss-name (push,"BSS")
#pragma data-name(push,"BSS")

#pragma rodata-name	("ROM0")
#pragma code-name	("ROM0")

const unsigned char strid0 [] = "ROM0";
const unsigned char some_chars_0_lzn [] = {
	0x40, 0x00, 0x70, 0x00, 0x0e, 0x0e, 0x1e, 0x3e, 0x3e, 0x76, 0x00, 0x67, 0x00, 0x0c, 0x0c, 0x1c, 
	0x34, 0x3c, 0x64, 0x00, 0x46, 0x00, 0x7e, 0x66, 0x6e, 0x7e, 0x67, 0x67, 0x00, 0x7e, 0x00, 0x7c, 
	0x44, 0x4c, 0x7c, 0x46, 0x46, 0x00, 0x7c, 0x00, 0x3e, 0x77, 0x60, 0x60, 0x70, 0x38, 0x00, 0x0f, 
	0x00, 0x3c, 0x66, 0x40, 0x40, 0x60, 0x30, 0x49, 0x0e, 0x9f, 0x37, 0x33, 0x80, 0x3e, 0x7c, 0x9f, 
	0x24, 0x26, 0x22, 0x80, 0x2c, 0x78, 0x9f, 0x70, 0x60, 0x08, 0x7c, 0x30, 0x30, 0x3f, 0x9f, 0x60, 
	0x40, 0x78, 0x04, 0x20, 0x20, 0x3e, 0x00, 0x3f, 0x8f, 0x78, 0x60, 0xe7, 0x08, 0x32, 0x08, 0x37, 
	0x8f, 0x70, 0x40, 0x08, 0x32, 0x08, 0x37, 0x08, 0x3f, 0x02, 0x6f, 0x63, 0x73, 0x1f, 0x00, 0x38, 
	0x08, 0x3f, 0x4e, 0x08, 0x42, 0x62, 0x1e, 0x00, 0x00
};

#pragma rodata-name	("ROM1")
#pragma code-name	("ROM1")

const unsigned char strid1 [] = "ROM1";
void write_something (void) {
	// Write something
	vram_adr (NAMETABLE_A + 328);
	for (gpit = 0; gpit < 16; gpit ++) vram_put (gpit);
}

#pragma rodata-name	("ROM2")
#pragma code-name	("ROM2")

const unsigned char strid2 [] = "ROM2";

#pragma rodata-name	("CODE")
#pragma code-name	("CODE")

// Music pointer(s)
extern const unsigned char music_ROM2 [];

const unsigned char simple_pal [] = {
	0x0F, 0x1D, 0x2D, 0x3D, 
	0x0F, 0x0F, 0x0F, 0x0F, 
	0x0F, 0x0F, 0x0F, 0x0F, 
	0x0F, 0x0F, 0x0F, 0x0F
};

void main (void) {
	bank_bg (0);
	bank_spr (1);

	pal_bg (simple_pal);
	
	// Page in ROM0
	bankswitch (0);

	// Decompress charset... TWICE.
	tokumaru_lzss (some_chars_0_lzn, 0);
	tokumaru_lzss (some_chars_0_lzn, 16*8);

	// Page in ROM1
	bankswitch (1);

	// Write something
	write_something ();

	// Configure and initialize famitone2:

	famitone_init (2, music_ROM2);

	ppu_on_all ();

	music_play (1);
	gpit = 0;
	while (1) {
		gpit = 1 - gpit; pal_col (0, 7+gpit);
		ppu_wait_nmi ();
	}
}
